// C Source File
// Created 7/23/2004; 10:41:45 PM

#include <tigcclib.h>
#include "defs.h"
void noLinkGame(void){
	short player=1;
	OCEAN oneSet={},twoSet={};//arays to hold the 
	FLEET oneShip={{PATROL,1,1,DOWN},{SUB,4,1,RIGHT},{DESTROYER,5,5,RIGHT},{BATTLESHIP,2,5,DOWN},{CARRIER,8,8,LEFT}},
	twoShip={{PATROL,1,1,DOWN},{SUB,4,1,RIGHT},{DESTROYER,5,5,RIGHT},{BATTLESHIP,2,5,DOWN},{CARRIER,8,8,LEFT}};
	POINT move;//used to save move by the user
	char buff[20];//string buffer for drawing to the screen
	getLayout(oneSet,oneShip);//have player one position their ships
	switchPlayers(2);//draw blank screan and message to swithc players so neither players see the other's setup
	getLayout(twoSet,twoShip);//have player two position their ships
	switchPlayers(1);
	//main game loop
	for(;;){
		drawGrid();
		move=getMove(player==1?twoSet:oneSet);//get a move from the player
		notifyHit_or_Miss(player==1?twoSet:oneSet,player==1?twoShip:oneShip,move);//check if the move was a hit or a miss and tell the player	
		if(hasWon(player==1?twoSet:oneSet,player==1?twoShip:oneShip))break;//check if they have won and break if they have
		//make it the next players turn
		player&=0x0001;//mask all but the last bit so player is 0 or one
		player++;//add one to player
		switchPlayers(player);
		drawGrid();
		DrawBord(player==2?twoSet:oneSet);//tell the player the status of their ships
		waitForKey();
	}
	darkScreen();
	//informe the players who the winner is
	FontSetSys(F_8x10);
	sprintf(buff,"Player %i is The",player);
	GrayDrawStr(18,39,buff,A_REVERSE);
	GrayDrawStr(50,51,"Winner",A_REVERSE);
	waitForKey();
	endGame();
}


//this is where the ai does all its thinking
//I think that an ai is important because
//that is one of the reisons to play on a
//calculator, so you can play alone
void AIMove(OCEAN bord,FLEET ships,AI *save){
	short i;
	const char *ship=NULL,*act=NULL;
	char buff[10];
	POINT move;
			do{
				if(!save->hit){//if we have not hit anything then move randomley
					do{
						move.y=random(10);
						move.x=random(10);					
						//only use the random number if it is not surounded by misses and has not been used befor
					}while(bord[move.y][move.x].flags>>6 && (isMiss(bord,move.y+1,move.x)||isMiss(bord,move.y,move.x+1)||isMiss(bord,move.y-1,move.x)||isMiss(bord,move.y,move.x-1)));
					break;
				}
				switch(save->dir){
					case UP:
						save->dir=RIGHT;
						move.x=save->lastHit.x;
						move.y=save->lastHit.y-1;
					break;
					case RIGHT:
						save->dir=DOWN;
						move.x=save->lastHit.x+1;
						move.y=save->lastHit.y;
					break;
					case DOWN:
						save->dir=LEFT;
						move.x=save->lastHit.x;
						move.y=save->lastHit.y+1;
					break;
					case LEFT:
						move.x=save->lastHit.x-1;
						move.y=save->lastHit.y;
						save->dir=UP;
						save->hit=FALSE;
				}//only use the move if it is on the bord and has not ben used befor
			}while(!isValid(move.x,move.y) || (bord[move.y][move.x].flags>>6));
			//put move on the bord
			
			for(i=0;i<5;i++){
				if(isHit(&ships[i],move)){
					bord[move.y][move.x].bits.hit=TRUE;
					save->lastHit=move;
					save->hitNum++;
					save->dir=UP;
					if(!save->hit && !save->hasFH){
						save->firstHit=move;
						save->hasFH=TRUE;
					}
					save->hit=1;
					ship=strs[i];
					if(isSunk(bord,&ships[i])){
						act=" Sunk";
						memset(save,0,sizeof(AI));//if the ship has been sunk then wipe the AI "memory"
					}else{
						act=" Hit";
					}
				}
			}	
			if(!bord[move.y][move.x].flags){
				bord[move.y][move.x].bits.miss=TRUE;
				//if we have come to the end of the ship whith out sinking it then we go back
				//the first place we hit that ship
				if(!save->hit && save->hasFH){
					save->lastHit=save->firstHit;
					save->dir=UP;
					save->hit=TRUE;
				}
				act="Miss";
			}
		//show the player where the ai moved
		drawGrid();
		GrayDrawStr(103,15,ship,A_NORMAL);
		GrayDrawStr(110,25,act,A_NORMAL);
		sprintf(buff,"[%c,%2i]",'A'+move.y,move.x+1);
		GrayDrawStr(110,50,buff,A_NORMAL);
		DrawBord(bord);//tell the player the status of their ships
		waitForKey();
}

void AIgame(void){
	OCEAN humanSet,AISet;
	AI save;//space for the ai to use for "memory"
	memset(&save,0,sizeof(AI));
	FLEET AIShip={{PATROL,1,1,DOWN},{SUB,4,1,RIGHT},{DESTROYER,5,5,RIGHT},{BATTLESHIP,2,5,DOWN},{CARRIER,8,8,LEFT}},
	humanShip={{PATROL,1,1,DOWN},{SUB,4,1,RIGHT},{DESTROYER,5,5,RIGHT},{BATTLESHIP,2,5,DOWN},{CARRIER,8,8,LEFT}};
	POINT move;
	randomLayout(AISet,AIShip);
	while(_rowread(0));
	getLayout(humanSet,humanShip);
	while(_rowread(0));
	for(;;){
		//human turn
		drawGrid();
		move=getMove(AISet);//get a move from the player
		notifyHit_or_Miss(AISet,AIShip,move);//check if the move was a hit or a miss and tell the player	
		if(hasWon(AISet,AIShip))break;//check if they have won and break if they have
		//ai turn
		
		AIMove(humanSet,humanShip,&save);//have the ai move
		
		if(hasWon(humanSet,humanShip))break;//check if the AI has won and break if they have
	}
	//if controle gets here then someone has won
	darkScreen();
	FontSetSys(F_8x10);
	if(hasWon(AISet,AIShip)){//find out who it is
		GrayDrawStr(30,39,"You Are the",A_REVERSE);
		GrayDrawStr(50,51,"Winner",A_REVERSE);
		waitForKey();
	}else{
		GrayDrawStr(40,39,"I Am the",A_REVERSE);
		GrayDrawStr(50,51,"Winner",A_REVERSE);
		waitForKey();
	}
	endGame();
}

//I don't know that this works verry well but it works better than the AI
//so I don't wory to much but sometimes it clusters ships together 
void randomLayout(OCEAN bord,FLEET ships){
	short i;
	memset(bord,0,sizeof(OCEAN));
	randomize();
	for(i=0;i<5;i++){
		do{	
			do{
				ships[i].x=random(10);
				ships[i].y=random(10);
				ships[i].dir=random(4);	
			}while(!CanDrawShip(&ships[i],ships[i].x,ships[i].y));
		}while(!PlaceShip(&ships[i],bord));
	}	
}

void LinkGame(void){
	OCEAN oneSet={},twoSet={};//arays to hold the 
	FLEET oneShip={{PATROL,1,1,DOWN},{SUB,4,1,RIGHT},{DESTROYER,5,5,RIGHT},{BATTLESHIP,2,5,DOWN},{CARRIER,8,8,LEFT}};
	POINT move;
	char turn;
	beginLink(oneSet,oneShip,twoSet);
	turn=status.bits.host;
	for(;;turn=(turn+1)&0x01){
		if(turn){
			move=getMove(twoSet);//get a move from the player
			darkScreen();
			FontSetSys(F_8x10);
			GrayDrawStr(18,39,"Waiting For",A_REVERSE);
			GrayDrawStr(50,51,"Response",A_REVERSE);
			notifyLinkHit_or_Miss(move,twoSet);
		}else{
			darkScreen();
			FontSetSys(F_8x10);
			GrayDrawStr(18,39,"Waiting For",A_REVERSE);
			GrayDrawStr(50,51,"Move",A_REVERSE);
			receveHit_or_Miss(oneSet,oneShip);
			drawGrid();
			DrawBord(oneSet);//tell the player the status of their ships
			waitForKey();
		}
	}
}

short isHit(SHIP *ship,POINT shot){
	short i;
	switch(ship->dir){
		case UP:
			if(ship->x!=shot.x)return FALSE;
			for(i=ship->y;i>((ship->y)-(ship->type&SIZE_MASK ));i--){
				if(i==shot.y)return TRUE;
			}
		break;
		case DOWN:
			if(ship->x!=shot.x)return FALSE;
			for(i=ship->y;i<(ship->y)+(ship->type&SIZE_MASK );i++){
				if(i==shot.y)return TRUE;
			}
		break;
		case LEFT:
			if(ship->y!=shot.y)return FALSE;
			for(i=ship->x;i>(ship->x)-(ship->type&SIZE_MASK );i--){
				if(i==shot.x)return TRUE;
			}
		break;	
		case RIGHT:
			if(ship->y!=shot.y)return FALSE;
			for(i=ship->x;i<(ship->x)+(ship->type&SIZE_MASK );i++){
				if(i==shot.x)return TRUE;
			}
	}
	return FALSE;
}

short isSunk(OCEAN bord,SHIP *ship){
	short i;
	switch(ship->dir){
		case UP:
			for(i=ship->y;i>((ship->y)-(ship->type&SIZE_MASK ));i--){
				if(bord[i][ship->x].bits.hit!=TRUE)return FALSE;
			}
		break;
		case DOWN:
			for(i=ship->y;i<(ship->y)+(ship->type&SIZE_MASK );i++){
				if(bord[i][ship->x].bits.hit!=TRUE)return FALSE;
			}
		break;
		case LEFT:
			for(i=ship->x;i>(ship->x)-(ship->type&SIZE_MASK );i--){
				if(bord[ship->y][i].bits.hit!=TRUE)return FALSE;
			}
		break;
		case RIGHT:
			for(i=ship->x;i<(ship->x)+(ship->type&SIZE_MASK );i++){
				if(bord[ship->y][i].bits.hit!=TRUE)return FALSE;
		}
	}
	return TRUE;
}


short hasWon(OCEAN bord,FLEET ships){
	short j;
	for(j=0;j<5;j++){
		if(!isSunk(bord,&ships[j]))return FALSE;	
	}
	return TRUE;
}

void endGame(void){
	if(status.bits.linked){
		endLink();
	}
	free(grid);
	GrayOff();
	
	SetIntVec(AUTO_INT_5, save_int_5); 
	SetIntVec(AUTO_INT_1, save_int_1);
	exit(0);
}