// C Source File
// Created 7/23/2004; 10:36:39 PM

#include <tigcclib.h>
#include "defs.h"

short PlaceShip(SHIP *toDraw,OCEAN bord){
	if(toDraw->type==NONE)return FALSE;
	short i;
	switch(toDraw->dir){
		case UP:
			for(i=toDraw->y;i>((toDraw->y)-(toDraw->type&SIZE_MASK ));i--){
				if(bord[i][toDraw->x].bits.ship!=0)return FALSE;
				bord[i][toDraw->x].bits.ship=TRUE;
			}
		break;
		case DOWN:
			for(i=toDraw->y;i<(toDraw->y)+(toDraw->type&SIZE_MASK );i++){
				if(bord[i][toDraw->x].bits.ship!=0)return FALSE;
				bord[i][toDraw->x].bits.ship=TRUE;
			}
		break;
		case LEFT:
			for(i=toDraw->x;i>(toDraw->x)-(toDraw->type&SIZE_MASK );i--){
				if(bord[toDraw->y][i].bits.ship!=0)return FALSE;
				bord[toDraw->y][i].bits.ship=TRUE;
			}
		break;
		case RIGHT:
			for(i=toDraw->x;i<(toDraw->x)+(toDraw->type&SIZE_MASK );i++){
				if(bord[toDraw->y][i].bits.ship!=0)return FALSE;
				bord[toDraw->y][i].bits.ship=TRUE;
		}
	}
	return TRUE;
}

short CanDrawShip(SHIP *toDraw,short x,short y){
	if(toDraw->type==NONE)return FALSE;
	if(x<0 || x>9 || y<0 || y>10)return FALSE;
	switch(toDraw->dir){
		case UP:
			if(y-((toDraw->type&SIZE_MASK )-2)<=0)return FALSE;
		break;
		case DOWN:
			if(y+((toDraw->type&SIZE_MASK ))>10)return FALSE;
		break;
		case LEFT:
			if(x-((toDraw->type&SIZE_MASK )-2)<=0)return FALSE;
		break;
		case RIGHT:
		if(x+((toDraw->type&SIZE_MASK ))>10)return FALSE;
	}
	return TRUE;
} 

void darkScreen(void){
	memset(GrayGetPlane(DARK_PLANE),0xFF,3000);
	memset(GrayGetPlane(LIGHT_PLANE),0xFF,3000);
}

void drawGrid(void){
	FastCopyScreen_R(grid,GrayGetPlane(DARK_PLANE));
	FastCopyScreen_R(grid,GrayGetPlane(LIGHT_PLANE));
}

void DrawShip(SHIP *toDraw,void *plane){
	if(toDraw->type==NONE)return;
	short i;
	switch(toDraw->dir){
		case UP:
			for(i=toDraw->y;i>((toDraw->y)-(toDraw->type&SIZE_MASK ));i--){
				DrawSq(toDraw->x*10,i*10,plane);
			}
		break;
		case DOWN:
			for(i=toDraw->y;i<(toDraw->y)+(toDraw->type&SIZE_MASK );i++){
				DrawSq(toDraw->x*10,i*10,plane);
			}
		break;
		case LEFT:
			for(i=toDraw->x;i>(toDraw->x)-(toDraw->type&SIZE_MASK );i--){
				DrawSq(i*10,toDraw->y*10,plane);
			}
		break;	
		case RIGHT:
			for(i=toDraw->x;i<(toDraw->x)+(toDraw->type&SIZE_MASK );i++){
				DrawSq(i*10,toDraw->y*10,plane);
			}
	}
}



/*void RemoveShip(SHIP *toDraw,OCEAN bord){
	if(toDraw->type==NONE)return;
	short i;
	switch(toDraw->dir){
		case UP:
			for(i=toDraw->y;i>((toDraw->y)-(toDraw->type&SIZE_MASK ));i--){
				bord[i][toDraw->x].bits.ship=FALSE;
			}
		break;
		case DOWN:	
			for(i=toDraw->y;i<(toDraw->y)+(toDraw->type&SIZE_MASK );i++){
				bord[i][toDraw->x].bits.ship=FALSE;
			}
		break;
		case LEFT:
			for(i=toDraw->x;i>(toDraw->x)-(toDraw->type&SIZE_MASK );i--){
				bord[toDraw->y][i].bits.ship=FALSE;
			}
		break;
		case RIGHT:
			for(i=toDraw->x;i<(toDraw->x)+(toDraw->type&SIZE_MASK );i++){
				bord[toDraw->y][i].bits.ship=FALSE;
		}
	}
}*/

short RotateShip(SHIP *toDraw,short dir){
	if(dir==CW){
		toDraw->dir++;
	}else{
		toDraw->dir--;
	}
	toDraw->dir&=(short)3;
	if(!CanDrawShip(toDraw,toDraw->x,toDraw->y)){
		if(dir==CW){
			toDraw->dir--;
		}else{
			toDraw->dir++;
		}
		toDraw->dir&=(short)3;
		return FALSE;
	}
	return TRUE;
}

void DrawBord_NS(OCEAN bord){
	short i,j;
		for(i=0;i<10;i++){
			for(j=0;j<10;j++){
				if(bord[j][i].bits.miss){
					DrawMiss(i*10,j*10);
				}
				if(bord[j][i].bits.hit){
					DrawHit(i*10,j*10);
				}
			}
		}
}

void DrawBord(OCEAN bord){
	short i,j;
		for(i=0;i<10;i++){
			for(j=0;j<10;j++){
				if(bord[j][i].bits.ship){
					DrawPeice(i*10,j*10);
				}
				if(bord[j][i].bits.miss){
					DrawMiss(i*10,j*10);
				}
				if(bord[j][i].bits.hit){
					DrawHit(i*10,j*10);
				}
			}
		}
}


